/*
	This will attempt to parse a Psion 3a Agenda file
	Copyright Straylight Productions, February, 1996
*/

parse arg filename

if ~show(l, "rexxsupport.library") then
    if ~addlib("rexxsupport.library",0,-30) then
        call exit_msg("Please install the rexxsupport.library in your libs: directory before running this Genie")

signal on error
signal on syntax
signal on break_c
signal on break_d
signal on break_e
signal on halt
signal on ioerr

address command
cr = '0a'x
lf = '0a'x
tb = '09'x


if ~open(file, filename, "r")
then
	do
	echo "Unable to open "filename
	exit
	end

sgna=readch(file,16)

if length(sgna)~=16
then
	do
	call close (file)
	echo "error in file signature: "sgna
	exit
	end


revi=readwd(file)
hdln=readwd(file)

echo sgna': 'revi': 'hdln

dross=readch(file,hdln-20)
records=0

c2=readch(file,1)
c1=readch(file,1)

do while ~eof(file)

	rt=bitand(c1,'F0'x)
	c1=bitand(c1,'0F'x)
	rt=c2d(rt)/16

	rcln=c2d(c1||c2)
	records=records+1

	select
		when rt=1 then
			do
			days1 = dy2dt(readwd(file))
			time1 = mn2tm(readwd(file))
			attr1 = readch(file,1)
			symb1 = readch(file,1)
			leng1 = readwd(file)
			styl1 = readch(file,1)
			slen1 = c2d(readch(file,1))
			text1 = readch(file,slen1)
			if c2d(symb1) < 32 then symb1 = " "
			echo rt days1 time1 c2x(attr1) leng1 symb1 c2x(styl1) text1
			end
		when rt=2 then
			do
			days1 = dy2dt(readwd(file))
			time1 = mn2tm(readwd(file))
			attr1 = readch(file,1)
			symb1 = readch(file,1)
			styl1 = readch(file,1)
			slen1 = c2d(readch(file,1))
			text1 = readch(file,slen1)
			if c2d(symb1) < 32 then symb1 = " "
			echo rt days1 time1 c2x(attr1) symb1 c2x(styl1) text1
			end
		when rt=3 then
			do
			days1 = dy2dt(readwd(file))
			time1 = mn2tm(readwd(file))
			attr1 = readch(file,1)
			symb1 = readch(file,1)
			year1 = readwd(file)
			disp1 = readch(file,1)
			styl1 = readch(file,1)
			slen1 = c2d(readch(file,1))
			text1 = readch(file,slen1)
			if c2d(symb1) < 32 then symb1 = " "
			echo rt days1 time1 c2x(attr1) symb1 year1 c2x(disp1) c2x(styl1) text1
			end
		when rt=4 then
			do
			days1 = dy2dt(readwd(file))
			time1 = mn2tm(readwd(file))
			attr1 = readch(file,1)
			symb1 = readch(file,1)
			dyby1 = readwd(file)
			hold1 = c2x(readch(file,1))
			type1 = c2x(readch(file,1))
			posn1 = (readwd(file,1) * 65536) + readwd(file)
			styl1 = readch(file,1)
			slen1 = c2d(readch(file,1))
			text1 = readch(file,slen1)
			if c2d(symb1) < 32 then symb1 = " "
			echo rt days1 time1 c2x(attr1) symb1 dyby1 hold1 type1 hold1 posn1 c2x(styl1) text1
			end
		otherwise
			do
			echo rt rcln
			dross=readch(file,rcln)
			os = ''
			do i = 1 to rcln
				os = os || c2x(substr(dross,i,1))
				if length(os) >=35
				then
					do
					echo os
					os = ""
					end
				else
					if (i//4=0) then os = os || ' '
			end
			echo os
			end
	end

	c2=readch(file,1)
	c1=readch(file,1)

end

call close(file)

echo "Total records: "records
echo 



exit


/* functions start here */


readwd: procedure
do
	parse arg file

	c2=readch(file,1)
	c1=readch(file,1)
	
	return (c2d(c1||c2))
	
end

dy2dt: procedure
do
	parse arg dayz

	dayz=dayz-2922
	
	if dayz<0 then return ("Bad Date")

	return (date('USA',dayz))
	
end

mn2tm: procedure
do
	parse arg mntz
	
	if mntz>1440 then mntz=0

	return (right(mntz%60,2,'0')":"right(mntz//60,2,'0'))
	
end

error:
syntax:
break_c:
break_d:
break_e:
break_f:
halt:
ioerr:
novalue:
do
	call close (file)
	echo "An Arexx error has occured interpeting Arexx string: "errortext(rc)" Line "SIGL
	return
end

